/* =========================================================================

NAME: ColumnSplitter

AUTHOR: Oleg Butrin (butrin@hotbox.ru)
HOMEPAGE: http://indesign.rudtp.ru
DATE  : 17.11.2003

COMMENT: Script split the selected textframe to some threaded

RIGHT:
You have the right to use and distribute this script.
You have the right to modify this script for own needs. 
It is desirable to send the variant to the author of a script.
You have no right to distribute the modified script from author's name.
You have no right to have profit from sale of a script.

The author of a script does not sustain the responsibility in all cases of loss data and other kinds of losses if they have arisen in the time of using a script.
You use this script at your own fear and risk.

============================================================================ */
// Check documents open
if (app.documents.length<1) {
	alert("No document open!\nOpen document, select textframe and try again.");
	exit()
}
// Check selection count and type
if ((app.selection.length != 1) || (app.selection[0].constructor.name != "TextFrame")) {
	alert("Select textframe and try again.");
	exit();
}
// Set variables
var myDoc = app.activeDocument;
var myTextFrame = app.selection[0];
var myTextFramePref = myTextFrame.textFramePreferences;
var myColumns = myTextFramePref.textColumnCount;
var myGutter = myTextFramePref.textColumnGutter;
var myBounds = myTextFrame.geometricBounds;
// Create UI
var myDialog = app.dialogs.add({name:"Split TextFrame"});
with (myDialog.dialogColumns.add()){
	with(dialogRows.add()){
		staticTexts.add({staticLabel:"Columns:", minWidth:50});
		var myUserColumns = integerEditboxes.add({editValue:myColumns});
	}
	with(dialogRows.add()){
		staticTexts.add({staticLabel:"Gutter:", minWidth:50});
		var myUserGutter = realEditboxes.add({editValue:myGutter});
	}
}
// Check cancel
myResult = myDialog.show();
if (myResult == false) {
 	exit();
}
// Read data from dialog
var myRealColumns = myUserColumns.editValue;
var myRealGutter = myUserGutter.editValue;
// Calculate size of every "splitted" textframes
var myWeight = (myBounds[3] - myBounds[1] - myRealGutter * (myRealColumns - 1)) / myRealColumns;
var myStep = myWeight + myRealGutter;
myBounds[3] = myBounds[1] + myWeight;
// Resize and "recolumn" base textframe
 with (myTextFrame){
 	textFramePreferences.textColumnCount = 1;
 	geometricBounds = myBounds;
 }
// Add textframes and change preferences
 for (var myCounter = 1; myCounter < myRealColumns; myCounter++) {
	myBounds[1] = myBounds[1] + myStep;
	myBounds[3] = myBounds[1] + myWeight;
	myTextFrame.nextTextFrame = myDoc.textFrames.add();
	myTextFrame.nextTextFrame.geometricBounds = myBounds;
 	with(myTextFrame.nextTextFrame.textFramePreferences){
// Uncomment next 3 lines if you want to set this preference
//  		firstBaselineOffset = myTextFrame.textFramePreferences.firstBaselineOffset;
//  		insetSpacing = myTextFrame.textFramePreferences.insetSpacing;
//  		minimumFirstBaselineOffset = myTextFrame.textFramePreferences.minimumFirstBaselineOffset;
 		ignoreWrap = myTextFrame.textFramePreferences.ignoreWrap;
 		textColumnCount = myTextFrame.textFramePreferences.textColumnCount;
 		verticalJustification = myTextFrame.textFramePreferences.verticalJustification;
 	} 
// Set next (in thread) textframe as current textframe	
	myTextFrame = myTextFrame.nextTextFrame;
 }
//  Kill dialog
 myDialog.destroy();